
;=========================================

include "table1.asm"

;=========================================
;   Z80

z80Reset:

xor	eax, eax
mov	[AF], eax
mov	[BC], eax
mov	[DE], eax
mov	[HL], eax
mov	[AF_], eax
mov	[BC_], eax
mov	[DE_], eax
mov	[HL], eax

mov	[IX], eax
mov	[IY], eax
mov	[PC], eax
mov	[SP_], eax

ret

;=========================================
;  

z80Exec:
ret

;=========================================
;  

z80Int:
ret

;=========================================
;    

z80NextB:

mov	eax, PC
call	z80Inc16

ret

;=========================================
;    

z80NextW:
ret

;=========================================
;  16 . 
;  eax -  
; :   F

z80Inc16:
inc	dword [eax]
;  ..    F
and	dword [eax], 0xffff
ret

;=========================================
;  8 .  (  16-)
;  eax -  
; :   F (  )

z80Inc8H:
push	ebx
mov	dword ebx, [eax]
and	dword [eax], 0xff
and	ebx, 0xff00
shr	ebx, 8
inc	ebx
;  ..    F
and	ebx, 0xff
shl	ecx, 8
or	dword [eax], ebx
pop	ebx
ret

;=========================================
;  8 .  (  16-)
;  eax -  
; :   F (  )

z80Inc8L:
push	ebx
mov	dword ebx, [eax]
and	dword [eax], 0xff00
inc	ebx
;  ..    F
and	ebx, 0xff
or	dword [eax], ebx
pop	ebx
ret

;=========================================
;    16 . 
;  eax -  
;  -  eax

z80GetH:
push	ebx
mov	dword ebx, [eax]
and	ebx, 0xff00 ;  , , ,  
shr	ebx, 8
mov	eax, ebx
and	eax, 0xff
pop	ebx
ret

;=========================================
;    16 . 
;  eax -  
;  -  eax

z80GetL:
push	ebx
mov	dword ebx, [eax]
and	ebx, 0xff
mov	eax, ebx
pop	ebx
ret

;=========================================
;    A
;  eax - ,    A
; :   F

z80AddA:
push	ebx
mov	ecx, eax
mov	ebx, [AF]
and	ebx, 0xff00 ;  , , ,  
shr	ebx, 8
add	ebx, eax
;  ..    F
and	ebx, 0xff
shl	ebx, 8
and	[AF], 0xff
or	[AF], ebx
pop	ebx
ret

;=========================================

; 16 .  
AF	dd 0
BC	dd 0
DE	dd 0
HL	dd 0
;  16 .   (AF', BC', DE', HL'):
AF_	dd 0
BC_	dd 0
DE_	dd 0
HL_	dd 0

; 16 . 
IX	dd 0
IY	dd 0
PC	dd 0
SP_	dd 0 ; SP    8086 :)

; 8 . 
I	dd 0 ;  
R	dd 0 ;   DRAM

;=========================================

;   Z80
MEM:
times 0x10000 db 0

;=========================================
